class FilterRGB
{
  float[] m_texOffsetValue;
  int m_valueNb;
  float m_stepy;
  int m_phaseR,m_phaseG,m_phaseB;
  float m_phase,m_phaseSpeed;
  int m_phaseInt;

  FilterRGB(int res, float amp, float freq)
  {
    m_phaseSpeed = 20.0f;
    m_phase = 0.0f;
    m_phaseInt = 0; 
  
    m_valueNb = res+1;
    m_stepy = 2.0f/(float)res;
    m_texOffsetValue = new float[m_valueNb];
    
    float a=0.0f;
    float step = 2.0f*PI/(float)res;
    for (int i=0;i<m_valueNb;i++)
    {
      m_texOffsetValue[i] = amp/512.0f * sin(freq*a);//10*(float)noise(a);/**/
      a+=step;
    }
    
    m_phaseR = m_valueNb/5;
    m_phaseG = 2*m_valueNb/5;
    m_phaseB = 3*m_valueNb/5;
  }
  
  void M_update(float dt)
  {
	m_phase += m_phaseSpeed*dt; 
	m_phaseInt = (int) m_phase;
	if (m_phaseInt >= m_valueNb) 
	  m_phase = 0.0f;
  }

  void M_drawChannel(int offset)
  {
	float	offset_x = 0.0f;
	float	offset_x2 = 0.0f;
	float	offset_y = 0.0f;
	float	y=-1.0f;
	float	texy=0.0f;
	float	step = 1.0f/(float)(m_valueNb-1);
	for (int i=0 ; i<m_valueNb-1 ; i++)
	{
		offset_x	= m_texOffsetValue[(offset+i)%m_valueNb];
		offset_x2	= m_texOffsetValue[(offset+i+1)%m_valueNb];
		
		opengl.glBegin(GL.GL_TRIANGLE_STRIP);
		opengl.glTexCoord2f(offset_x, texy)				;opengl.glVertex3f(-1.0f,  y, 0.0f);
		opengl.glTexCoord2f(offset_x2, texy+step)			;opengl.glVertex3f(-1.0f,  y+m_stepy, 0.0f);
		opengl.glTexCoord2f(1.0f+offset_x, texy)			;opengl.glVertex3f( 1.0f,  y, 0.0f);
		opengl.glTexCoord2f(1.0f+offset_x2, texy+step)	                ;opengl.glVertex3f( 1.0f,  y+m_stepy, 0.0f);
		opengl.glEnd();		

		y+=m_stepy;
		texy+=step;
      }
  }
  
  void M_apply()
  {
	// R
	opengl.glColorMask(true, false, false, true);
	M_drawChannel(m_phaseR+m_phaseInt);
	// V
	opengl.glColorMask(false, true, false, true);
	M_drawChannel(m_phaseG+m_phaseInt);

	// B
	opengl.glColorMask(false, false, true, true);
	M_drawChannel(m_phaseB+m_phaseInt);

	// RVBA
	opengl.glColorMask(true, true, true, true);

  }
}

