// --------------------------------------------
// class Texture
// --------------------------------------------
class Texture
{
  int[] texName;
  int width, height;
  PImage img;

  Texture()
  {
    texName = new int[1];
  }

  void update(PImage img)
  {
    this.img = img;
    int nbPix = img.width*img.height;
    for (int i=0;i<nbPix;i++)
      img.pixels[i] |= 0xFF000000;
  
    opengl.glEnable(GL.GL_TEXTURE_2D);
    opengl.glBindTexture(GL.GL_TEXTURE_2D, texName[0]);
    opengl.glTexSubImage2D(GL.GL_TEXTURE_2D,0,0,0,img.width,img.height,GL.GL_BGRA_EXT,GL.GL_UNSIGNED_BYTE,img.pixels);
    opengl.glDisable(GL.GL_TEXTURE_2D);
  }


  void createFromImage(String imgStr)
  {
    PImage tex = loadImage(imgStr);

    if (tex != null)
    {
      createBlank(tex.width, tex.height);
      update(tex);
    }
  }

  void createBlank(int w, int h)
  {
    width   = snapTo2nHigh(w);
    height  = snapTo2nHigh(h);

    int[] pixels = new int[width*height];
    for (int i=0;i<width*height;i++)
      pixels[i] = 0xFF0000FF;

    opengl.glGenTextures(1,texName);
    opengl.glEnable(GL.GL_TEXTURE_2D);
    opengl.glPixelStorei(GL.GL_UNPACK_ALIGNMENT, 1);
    opengl.glBindTexture(GL.GL_TEXTURE_2D, texName[0]);
    opengl.glTexImage2D(GL.GL_TEXTURE_2D, 0, 4, width, height, 0, GL.GL_BGRA_EXT, GL.GL_UNSIGNED_BYTE, pixels);    
    opengl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MAG_FILTER, GL.GL_LINEAR);
    opengl.glTexParameterf(GL.GL_TEXTURE_2D, GL.GL_TEXTURE_MIN_FILTER, GL.GL_LINEAR);
    opengl.glTexEnvf(GL.GL_TEXTURE_ENV, GL.GL_TEXTURE_ENV_MODE, GL.GL_REPLACE);
    opengl.glDisable(GL.GL_TEXTURE_2D);

  }

  void drawBackground()
  {
    opengl.glDisable(GL.GL_DEPTH_TEST);
    opengl.glEnable(GL.GL_TEXTURE_2D);
    opengl.glBindTexture(GL.GL_TEXTURE_2D, texName[0]); 
    opengl.glBegin(GL.GL_QUADS);
    
      opengl.glTexCoord2f(0.0f,0.0f);
      opengl.glVertex2f(0.0f, 1.0f);
    
      opengl.glTexCoord2f(0.0f,1.0f);	
      opengl.glVertex2f(1.0f, 1.0f);
    
      opengl.glTexCoord2f(1.0f,1.0f);		
      opengl.glVertex2f( 1.0f, 0.0f);
      
      opengl.glTexCoord2f(1.0f,0.0f);	
      opengl.glVertex2f( 0.0f, 0.0f);
    
    opengl.glEnd();
    opengl.glDisable(GL.GL_TEXTURE_2D);
    opengl.glEnable(GL.GL_DEPTH_TEST);
  }

}

// --------------------------------------------
// class videoTexture
// --------------------------------------------
class videoTexture extends Texture
{
  Movie video;

   videoTexture(){
    super();
  }

  void setMovie(Movie video)
  {
    this.video = video;
    createBlank(video.width, video.height);
  }

  void update()
  {
    this.update(video);
  }

  float getU(){
    return (float)video.width/(float)width;
  }
  float getV(){
    return (float)video.height/(float)height;
  }

}


